%{?dist: %{expand: %%define dist_%dist 1}}

%define bver 2.2.5

Summary:     Bacula - The Network Backup Solution
Name:        bacula
Version:     %{bver}
Release:     2%{?dist:.%{dist}}%{?pext}
License:     GPL
Group:       System Environment/Daemons
Source0:     http://prdownloads.sourceforge.net/sourceforge/%{name}/%{name}-%{version}.tar.gz
Source4:     %{name}-dir.init
Source5:     %{name}-sd.init
Source6:     %{name}-fd.init
Source7:     %{name}.sysconfig
Patch0:      http://prdownloads.sourceforge.net/sourceforge/%{name}/%{version}-nextvol.patch
Patch10:     %{name}-2.2.5-build.patch
Patch11:     %{name}-2.2.5-paths.patch
Patch12:     %{name}-2.2.5-install.patch
Patch13:     %{name}-2.2.5-cats.patch
URL:         http://www.%{name}.org/
Buildroot:   /var/tmp/%{name}-root
Vendor:      The Bacula Team
Packager:    Peter Pramberger <peter.pramberger@member.fsf.org>
Provides:    %{name}%{?pext}
Requires:    libstdc++ openssl097 zlib
Prereq:      fileutils glibc
BuildPrereq: fileutils glibc-devel gcc-c++ make
BuildPrereq: autoconf259 gettext libstdc++-devel
BuildPrereq: mysql-devel libtermcap-devel openssl097-devel
BuildPrereq: pkgconfig readline-devel tcp_wrappers zlib-devel
ExclusiveOS: linux

%description
Bacula is a set of computer programs that permit you to manage
backup, recovery, and verification of computer data across a
network of computers of different kinds. In technical terms,
it is a network client/server based backup program. Bacula is
relatively easy to use and efficient, while offering many
advanced storage management features that make it easy to find
and recover lost or damaged files.


%package client
Summary:     The Bacula backup client
Group:       System Environment/Daemons
Provides:    %{name}-client%{?pext}
Requires:    %{name} = %{version}-%{release} %{name}%{?pext}
Requires:    tcp_wrappers

%description client
This package contains the Bacula File service (also known as the
Client program) is the software program that is installed on the
machine to be backed up. It is specific to the operating system
on which it runs and is responsible for providing file attributes
and data when requested by the Director. The File services are
also responsible for the file system dependent part of restoring
the file attributes and data during a recovery operation.


%package console
Summary:     The Bacula command console
Group:       Applications/System
Provides:    %{name}-console%{?pext}
Requires:    %{name} = %{version}-%{release} %{name}%{?pext}
Requires:    libtermcap

%description console
This package contains the Bacula Console service, which is the
program that allows the administrator or user to communicate with
the Bacula Director. It provides a text-based console interface.


%package server-mysql
Summary:     The Bacula server for MySQL backends
Group:       System Environment/Daemons
Provides:    %{name}-server-mysql%{?pext} %{name}-server
Requires:    %{name} = %{version}-%{release} %{name}%{?pext}
Requires:    mysql perl tcp_wrappers

%description server-mysql
This package contains the Bacula server daemons which use
MySQL as database backend for the Catalog service.

The Bacula Director service is the program that supervises
all the backup, restore, verify and archive operations. The
system administrator uses the Bacula Director to schedule
backups and to recover files. The Director runs as a daemon
in the background.

The Bacula Storage services consist of the software programs
that perform the storage and recovery of the file attributes
and data to the physical backup media or volumes. In other
words, the Storage daemon is responsible for reading and
writing your tapes (or other storage media, e.g. files). It
runs as a daemon on the machine that has the backup device
(usually a tape drive).


%prep
%setup -q
%patch0 -p0 -b .nextvol
%patch10 -p1 -b .build
%patch11 -p1 -b .paths
%patch12 -p1 -b .install
%patch13 -p1 -b .cats

# Other patches
%{__patch} -p1 <patches/testing/clientrunbeforejob_can_generate_include_exclude_list.patch

# Rebuild autotools
pushd autoconf
  %{__autoconf}-2.59
popd

%{__mv} -f autoconf/configure .

# Fix permissions
pushd examples
  find -name "*.pl" -type f -exec %{__chmod} a-x {} \;
  %{__chmod} a-x afs-bacula reports/checkhost
popd


%build
BuildApp() {
  %configure \
	CPPFLAGS="-I%{_prefix}/kerberos/include"           \
	CFLAGS="-I%{_prefix}/kerberos/include %{optflags}" \
	OPENSSL=%{_bindir}/openssl097                      \
	--sbindir=%{_bindir}                               \
	--sysconfdir=%{_sysconfdir}/%{name}                \
	--with-scriptdir=%{_sysconfdir}/%{name}/scripts    \
	--with-archivedir=/tmp                             \
	--enable-smartalloc                                \
	--enable-ipv6                                      \
	--with-openssl                                     \
	--with-readline                                    \
	--with-tcp-wrappers                                \
	--with-dir-user=%{name}                            \
	--with-dir-group=%{name}                           \
	--with-sd-user=%{name}                             \
	--with-sd-group=disk                               \
	--with-fd-user=root                                \
	--with-fd-group=%{name}                            \
	--with-working-dir=%{_localstatedir}/lib/%{name}   \
	--with-dir-password="XXX_DIR_PASS_XXX"             \
	--with-fd-password="XXX_FD_PASS_XXX"               \
	--with-sd-password="XXX_SD_PASS_XXX"               \
	--with-mon-dir-password="XXX_DIR_MON_PASS_XXX"     \
	--with-mon-fd-password="XXX_FD_MON_PASS_XXX"       \
	--with-mon-sd-password="XXX_SD_MON_PASS_XXX"       \
	$1

  %{__make} \
	all

  for FILE in src/dird/%{name}-dir src/stored/bcopy src/stored/bscan src/tools/dbcheck; do
    %{__cp} -f ${FILE} ${FILE}-$2
  done
}

BuildApp "--with-mysql" "mysql"


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_initrddir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/{%{name}/updatedb,sysconfig,logrotate.d}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/log.d/{scripts/services,conf/{logfiles,services}}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_bindir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sbindir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_datadir}/%{name}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_localstatedir}/{lib,log}/%{name}

%{__make} \
	DESTDIR=${RPM_BUILD_ROOT} \
	install

%{__mv} -f ${RPM_BUILD_ROOT}%{_bindir}/%{name}-{fd,sd} ${RPM_BUILD_ROOT}%{_sbindir}

%{__install} -m 0755 src/stored/{bcopy-*,bscan-*} ${RPM_BUILD_ROOT}%{_bindir}
%{__install} -m 0755 src/tools/{dbcheck-*,*type}  ${RPM_BUILD_ROOT}%{_bindir}
%{__install} -m 0755 src/tools/{testfind,testls}  ${RPM_BUILD_ROOT}%{_bindir}
%{__install} -m 0755 src/dird/%{name}-dir-*       ${RPM_BUILD_ROOT}%{_sbindir}

%{__rm} -f ${RPM_BUILD_ROOT}%{_bindir}/{%{name}-dir,bcopy,bscan,dbcheck}

%{__install} -m 0755 %{SOURCE4} ${RPM_BUILD_ROOT}%{_initrddir}/%{name}-dir
%{__install} -m 0755 %{SOURCE5} ${RPM_BUILD_ROOT}%{_initrddir}/%{name}-sd
%{__install} -m 0755 %{SOURCE6} ${RPM_BUILD_ROOT}%{_initrddir}/%{name}-fd
%{__install} -m 0644 %{SOURCE7} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{name}
%{__install} -m 0644 scripts/logrotate ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}

%{__cp} -prd         examples   ${RPM_BUILD_ROOT}%{_datadir}/%{name}

%{__rm} -f ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/scripts/{%{name},%{name}-ctl*,[bg]console}
%{__rm} -f ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/scripts/{start,stop}mysql
%{__rm} -f ${RPM_BUILD_ROOT}%{_mandir}/man1/{%{name}-bgnome*,%{name}-bwxconsole*,%{name}-tray*,bat}.*

# Install DB update scripts
%{__install} -m 0644 updatedb/README ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/updatedb
%{__install} -m 0755 updatedb/update_mysql_* ${RPM_BUILD_ROOT}%{_sysconfdir}/%{name}/updatedb

# Install logwatch addons
%{__install} -m 0755 scripts/logwatch/%{name}                     \
	${RPM_BUILD_ROOT}%{_sysconfdir}/log.d/scripts/services
%{__install} -m 0644 scripts/logwatch/logfile.%{name}.conf        \
	${RPM_BUILD_ROOT}%{_sysconfdir}/log.d/conf/logfiles/%{name}.conf
%{__install} -m 0644 scripts/logwatch/services.%{name}.conf \
	${RPM_BUILD_ROOT}%{_sysconfdir}/log.d/conf/services/%{name}.conf


%pre
if ! %{__id} -g %{name} >/dev/null 2>&1; then
  groupadd -r %{name}
fi
if ! %{__id} -u %{name} >/dev/null 2>&1; then
  useradd  -g %{name} -G %{name},disk       \
	   -d %{_localstatedir}/lib/%{name} \
	   -r -s /sbin/nologin %{name}
fi


%post
[ -f %{_sysconfdir}/%{name}/support.pkg ] || {
  touch                %{_sysconfdir}/%{name}/support.pkg
  %{__chown} root:root %{_sysconfdir}/%{name}/support.pkg
  %{__chmod} 0600      %{_sysconfdir}/%{name}/support.pkg

  HOSTNAME=`uname -n | cut -d. -f1`
  echo "HOSTNAME=${HOSTNAME}"    >>%{_sysconfdir}/%{name}/support.pkg

  for STRING in DIR_PASS FD_PASS SD_PASS DIR_MON_PASS FD_MON_PASS SD_MON_PASS; do
    PASSWORD=`openssl097 rand -base64 36`
    echo "${STRING}=${PASSWORD}" >>%{_sysconfdir}/%{name}/support.pkg
  done
}

%post client
if [ $1 = 1 ]; then
  chkconfig --add %{name}-fd
  chkconfig %{name}-fd on
fi

# Update config
for STRING in HOSTNAME FD_PASS FD_MON_PASS; do
  REPLACE=`%{__grep} ${STRING} %{_sysconfdir}/%{name}/support.pkg 2>/dev/null | cut -d= -f2`

  if [ -n "${REPLACE}" ]; then
    sed -i -e "s:XXX_${STRING}_XXX:${REPLACE}:g" %{_sysconfdir}/%{name}/%{name}-fd.conf
  fi
done

if [ -f %{_localstatedir}/lock/subsys/%{name}-fd ]; then
  %{_initrddir}/%{name}-fd restart
fi

%post console
# Update config
for STRING in HOSTNAME DIR_PASS; do
  REPLACE=`%{__grep} ${STRING} %{_sysconfdir}/%{name}/support.pkg 2>/dev/null | cut -d= -f2`

  if [ -n "${REPLACE}" ]; then
    sed -i -e "s:XXX_${STRING}_XXX:${REPLACE}:g" %{_sysconfdir}/%{name}/bconsole.conf
  fi
done

%post server-mysql
if [ $1 = 1 ]; then
  chkconfig --add %{name}-sd
  chkconfig %{name}-sd on
  chkconfig --add %{name}-dir
  chkconfig %{name}-dir on
fi

%{__ln_s} -f dbcheck-mysql     %{_bindir}/dbcheck
%{__ln_s} -f bcopy-mysql       %{_bindir}/bcopy
%{__ln_s} -f bscan-mysql       %{_bindir}/bscan
%{__ln_s} -f %{name}-dir-mysql %{_sbindir}/%{name}-dir

# Update config
for STRING in HOSTNAME DIR_PASS FD_PASS SD_PASS DIR_MON_PASS SD_MON_PASS; do
  REPLACE=`%{__grep} ${STRING} %{_sysconfdir}/%{name}/support.pkg 2>/dev/null | cut -d= -f2`

  if [ -n "${REPLACE}" ]; then
    sed -i -e "s:XXX_${STRING}_XXX:${REPLACE}:g" %{_sysconfdir}/%{name}/%{name}-dir.conf
    sed -i -e "s:XXX_${STRING}_XXX:${REPLACE}:g" %{_sysconfdir}/%{name}/%{name}-sd.conf
  fi
done

if [ -f %{_localstatedir}/lock/subsys/%{name}-sd ]; then
  %{_initrddir}/%{name}-sd restart
fi
if [ -f %{_localstatedir}/lock/subsys/%{name}-dir ]; then
  %{_initrddir}/%{name}-dir restart
fi


%preun
if [ $1 = 0 ]; then
  %{__rm} -f %{_sysconfdir}/%{name}/support.pkg
fi

%preun client
if [ $1 = 0 ]; then
  chkconfig %{name}-fd off
  chkconfig --del %{name}-fd

  if [ -f %{_localstatedir}/lock/subsys/%{name}-fd ]; then
    %{_initrddir}/%{name}-fd stop
  fi
fi

%preun server-mysql
if [ $1 = 0 ]; then
  chkconfig %{name}-dir off
  chkconfig --del %{name}-dir
  chkconfig %{name}-sd off
  chkconfig --del %{name}-sd

  if [ -f %{_localstatedir}/lock/subsys/%{name}-dir ]; then
    %{_initrddir}/%{name}-dir stop
  fi
  if [ -f %{_localstatedir}/lock/subsys/%{name}-sd ]; then
    %{_initrddir}/%{name}-sd stop
  fi

  %{__rm} -f %{_bindir}/{dbcheck,bcopy,bscan}
  %{__rm} -f %{_sbindir}/%{name}-dir
fi


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc ABOUT-NLS AUTHORS COPYING ChangeLog INSTALL LICENSE
%doc README SUPPORT kernstodo projects technotes*
%attr(755,root,%{name}) %dir %{_sysconfdir}/%{name}
%attr(750,%{name},%{name}) %dir %{_sysconfdir}/%{name}/scripts
%{_sysconfdir}/%{name}/scripts/btraceback*
%config(noreplace) %{_sysconfdir}/logrotate.d/*
%config(noreplace) %{_sysconfdir}/sysconfig/*
%attr(755,root,%{name}) %{_bindir}/bsmtp
%attr(755,root,%{name}) %{_bindir}/bregex
%attr(755,root,%{name}) %config(noreplace) %{_bindir}/btraceback
%attr(755,root,%{name}) %{_bindir}/bwild
%attr(755,root,%{name}) %{_bindir}/test*
%attr(755,root,%{name}) %{_bindir}/*type
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*
%{_mandir}/man1/bsmtp*
%{_mandir}/man8/bacula.*
%{_mandir}/man8/btraceback*
%attr(755,%{name},%{name}) %dir %{_localstatedir}/lib/%{name}
%attr(755,%{name},%{name}) %dir %{_localstatedir}/log/%{name}

%files client
%defattr(-,root,root)
%{_initrddir}/%{name}-fd
%attr(640,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/%{name}-fd.conf
%attr(751,root,%{name}) %{_sbindir}/%{name}-fd
%{_mandir}/man8/%{name}-fd*

%files console
%defattr(-,root,root)
%attr(640,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/bconsole.conf
%attr(751,root,%{name}) %{_bindir}/bconsole
%{_mandir}/man8/bconsole*

%files server-mysql
%defattr(-,root,root)
%{_initrddir}/%{name}-dir
%{_initrddir}/%{name}-sd
%{_sysconfdir}/log.d/scripts/services/*
%{_sysconfdir}/log.d/conf/logfiles/*
%{_sysconfdir}/log.d/conf/services/*
%attr(640,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/%{name}-dir.conf
%attr(640,root,disk) %config(noreplace) %{_sysconfdir}/%{name}/%{name}-sd.conf
%attr(750,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/scripts/*_bacula_*
%attr(750,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/scripts/*_catalog_*
%attr(750,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/scripts/*_mysql_*
%attr(750,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/scripts/dvd-handler
%attr(750,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/scripts/*-changer
%attr(640,root,%{name}) %config(noreplace) %{_sysconfdir}/%{name}/scripts/query.sql
%attr(750,root,%{name}) %dir %{_sysconfdir}/%{name}/updatedb
%{_sysconfdir}/%{name}/updatedb/README
%{_sysconfdir}/%{name}/updatedb/update_mysql_*
%attr(751,root,%{name}) %{_bindir}/dbcheck-mysql
%attr(751,root,%{name}) %{_bindir}/bcopy-mysql
%attr(751,root,%{name}) %{_bindir}/bscan-mysql
%attr(751,root,%{name}) %{_bindir}/bls
%attr(751,root,%{name}) %{_bindir}/bextract
%attr(751,root,%{name}) %{_bindir}/btape
%attr(751,root,%{name}) %{_sbindir}/%{name}-dir-mysql
%attr(751,root,disk) %{_sbindir}/%{name}-sd
%{_mandir}/man8/%{name}-dir*
%{_mandir}/man8/%{name}-sd*
%{_mandir}/man8/bcopy*
%{_mandir}/man8/bextract*
%{_mandir}/man8/bls*
%{_mandir}/man8/bscan*
%{_mandir}/man8/btape*
%{_mandir}/man8/dbcheck*


%changelog
* Wed Nov 07 2007 peter.pramberger@member.fsf.org 2.2.5-2
- created

